VERSION 5.00
Begin VB.UserControl XPdivider 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   252
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4440
   FillColor       =   &H80000002&
   LockControls    =   -1  'True
   ScaleHeight     =   252
   ScaleWidth      =   4440
   ToolboxBitmap   =   "XPdivider.ctx":0000
End
Attribute VB_Name = "XPdivider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*******************************************************************************************************
'********************************************
'*********************              XpDivider (Part of XpControls)
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'* Feel free to use/modify this code, but:
'* - Please do not spread this code in modified form.
'* - Do not rename this control and spread its source.
'* - Leave this text where it is.
'* - Give proper credit to the author.
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Option Explicit

Private meBackStyle As BackStyleConstants
Private mCaption As String
Private mUseThemeColors As Boolean
Private mUseColorCheat As Boolean
Private meUseParentFormhDC As Boolean
Private m_hWnd As Long
Private h1 As Long
Private h2 As Long
Private bMnemonic As Boolean

Private Const ClientSideNotAvailable  As Long = 398          ' Client Side Not Available VB error code.

Private WithEvents MyParent As Form
Attribute MyParent.VB_VarHelpID = -1

Private Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
    ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" ( _
   ByVal hLibModule As Long) As Long

Private m_hMod As Long

' Legacy option (check) buttons
Private Const DFC_BUTTON As Long = 4&
Private Const DFCS_BUTTONRADIO As Long = &H4&
Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_CHECKED As Long = &H400&
Private Const DFCS_INACTIVE = &H100
  
Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC&, lpRect As RECT, ByVal un1&, ByVal un2&) As Long

'------------------------------------------------------

Private Const SW_HIDE = 0
Private Const SW_SHOW = 5

Private Const WM_NOTIFY = &H4E
Private Const WM_MOUSEMOVE = &H200

Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8

Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Private Type PicBmp
   SIZE As Long
   type As Long
   hBmp As Long
   hPal As Long
   Reserved As Long
End Type

Private Type DTBGOPTS
    dwSize As Long
    dwFlags As Long
    rcClip As RECT
End Type

Private Type Margins
    cxLeftWidth As Long
    cxRightWidth As Long
    cyTopHeight As Long
    cyBottomHeight As Long
End Type

Private Type NMHDR
    hWndFrom As Long
    idFrom As Long
    Code As Long
End Type

Private Const LF_FACESIZE = 32

Private Type FONTSLOG   ' is naturally DWORD aligned (8 Byte members)...
  flfHeight As Long
  flfWidth As Long
  flfEscapement As Long
  flfOrientation As Long
  flfWeight As Long
  flfItalic As Byte
  flfUnderline As Byte
  flfStrikeOut As Byte
  flfCharSet As Byte
  flfOutPrecision As Byte
  flfClipPrecision As Byte
  flfQuality As Byte
  flfPitchAndFamily As Byte
  flfFaceName As String * LF_FACESIZE
End Type

Private Declare Function OpenThemeData Lib "uxtheme.dll" _
   (ByVal hWnd As Long, ByVal pszClassList As Long) As Long

Private Declare Function CloseThemeData Lib "uxtheme.dll" _
   (ByVal hTheme As Long) As Long

Private Declare Function DrawThemeText Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
    ByVal iStateId As Long, ByVal pszText As Long, _
    ByVal iCharCount As Long, ByVal dwTextFlag As Long, _
    ByVal dwTextFlags2 As Long, pRect As RECT) As Long
    
Private Declare Function DrawThemeBackground Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
    
Private Declare Function GetThemeFont Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal hDC As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   tLogFont As FONTSLOG) As Long
    
Private Declare Function GetThemeColor Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   ByRef pColor As OLE_COLOR) As Long
                 
Private Const DT_LEFT = &H0
Private Const DT_TOP = &H0
Private Const DT_CENTER = &H1
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8&
Private Const DT_SINGLELINE = &H20
Private Const BP_PUSHBUTTON = 1
Private Const BP_RADIOBUTTON = 2
Private Const BP_CHECKBOX = 3
Private Const BP_GROUPBOX = 4
Private Const BP_USERBUTTON = 5

Private Const PBS_NORMAL = 1
Private Const PBS_HOT = 2
Private Const PBS_PRESSED = 3
Private Const PBS_DISABLED = 4
Private Const PBS_DEFAULTED = 5
Private Const TMT_FONT = 210

Private Const EP_EDITTEXT = 1
Private Const ETS_NORMAL = 1
Private Const ETS_DISABLED = 4

Private Const PP_BAR = 1
Private Const PP_NORMAL = 1

Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8

Private Const BDR_OUTER = (BDR_RAISEDOUTER Or BDR_SUNKENOUTER)
Private Const BDR_INNER = (BDR_RAISEDINNER Or BDR_SUNKENINNER)
Private Const BDR_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const BDR_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)

Private Const BF_MIDDLE = &H800             '/* Fill in the middle */
Private Const BF_SOFT = &H1000              '/* For softer buttons */
Private Const BF_ADJUST = &H2000            '/* Calculate the space left over */
Private Const BF_FLAT = &H4000              '/* For flat rather than 3D borders */
Private Const BF_MONO = &H8000              '/* For monochrome borders */

Private Const TMT_BORDERCOLORHINT = 3822    ' hint about border color used (for custom controls)

Private Const m_def_BackStyle = Transparent

Public Property Get UseColorCheat() As Boolean
Attribute UseColorCheat.VB_Description = "If the dividerline isn't the expected color, set UseColorCheat to true. (This  happens when using the Media Center MsStyle on XP)"
   UseColorCheat = mUseColorCheat
End Property

Public Property Let UseColorCheat(ByVal Setting As Boolean)
   mUseColorCheat = Setting
   Redraw
   PropertyChanged "UseColorCheat"
End Property

Public Property Get Themed() As Boolean
Attribute Themed.VB_Description = "Use the current theme GroupBox colors, instead of legacy 3D colors."
   Themed = mUseThemeColors
End Property

Public Property Let Themed(ByVal Setting As Boolean)
   mUseThemeColors = Setting
   Redraw
   PropertyChanged "Themed"
End Property

Public Property Get UseParentFormhDC() As Boolean
Attribute UseParentFormhDC.VB_Description = "Use Parent as a source for the transparency regardless whether the control is contained by another control. This can be useful when working with a vbTabStrip for example when you're using DrawTabStripCheat."
   UseParentFormhDC = meUseParentFormhDC
End Property

Public Property Let UseParentFormhDC(ByVal Setting As Boolean)
   meUseParentFormhDC = Setting
   PropertyChanged "UseParentFormhDC"
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Although displayed, the default theme or Windows 3D colors are used."
   BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal Setting As OLE_COLOR)
   UserControl.BackColor() = Setting
   Redraw
   PropertyChanged "BackColor"
End Property

Public Property Get BackStyle() As BackStyleConstants
Attribute BackStyle.VB_Description = "Transparent will show what's behind the control, Opaque has the default vbButtonFace color."
   BackStyle = meBackStyle
End Property

Public Property Let BackStyle(ByVal Setting As BackStyleConstants)
   meBackStyle = Setting
   Redraw
   PropertyChanged "BackStyle"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Although displayed, the default theme or Windows 3D colors are used."
   ForeColor = UserControl.ForeColor
End Property

Private Property Let ForeColor(ByVal Setting As OLE_COLOR)
   UserControl.ForeColor() = Setting
   Redraw
   PropertyChanged "ForeColor"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "The current Theme (System) Font will be used."
   Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal Setting As Font)
   Set UserControl.Font = Setting
   Redraw
   PropertyChanged "Font"
End Property

Private Sub UserControl_Initialize()

   m_hMod = LoadLibrary("shell32.dll")
   
End Sub

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Set the Caption for XpDivider."
   Caption = mCaption
End Property

Public Property Let Caption(ByVal Setting As String)
   If InStrB(Setting, "&") <> 0 Then
      bMnemonic = True
   Else
      bMnemonic = False
   End If
   If bMnemonic Then
      MsgBox "XpDivider can't get the focus, therefore Mnemonics aren't allowed.", vbExclamation, "XpControls"
   Else
      mCaption = Setting
      UserControl.Height = UserControl.TextHeight("T") '+ ScaleY(4, vbPixels, vbTwips)
      Redraw
      PropertyChanged "Caption"
   End If
End Property

Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_MemberFlags = "400"
   FontUnderline = UserControl.FontUnderline
End Property

Public Property Let FontUnderline(ByVal Setting As Boolean)
   UserControl.FontUnderline = Setting
   Redraw
   PropertyChanged "FontUnderline"
End Property

Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_MemberFlags = "400"
   FontStrikethru = UserControl.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal Setting As Boolean)
   UserControl.FontStrikethru = Setting
   Redraw
   PropertyChanged "FontStrikethru"
End Property

Public Property Get FontSize() As Single
Attribute FontSize.VB_MemberFlags = "400"
   FontSize = UserControl.FontSize
End Property

Public Property Let FontSize(ByVal Setting As Single)
On Error Resume Next
   UserControl.FontSize = Setting
   Redraw
   PropertyChanged "FontSize"
On Error GoTo 0
End Property

Public Property Get FontName() As String
Attribute FontName.VB_MemberFlags = "400"
   FontName = UserControl.FontName
End Property

Public Property Let FontName(ByVal Setting As String)
On Error Resume Next
   UserControl.FontName = Setting
   Redraw
   PropertyChanged "FontName"
On Error GoTo 0
End Property

Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_MemberFlags = "400"
   FontItalic = UserControl.FontItalic
End Property

Public Property Let FontItalic(ByVal Setting As Boolean)
   UserControl.FontItalic = Setting
   Redraw
   PropertyChanged "FontItalic"
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_MemberFlags = "400"
   FontBold = UserControl.FontBold
End Property

Public Property Let FontBold(ByVal Setting As Boolean)
   UserControl.FontBold = Setting
   Redraw
   PropertyChanged "FontBold"
End Property

Public Property Get hWnd() As Long
   hWnd = UserControl.hWnd
End Property

Private Sub UserControl_InitProperties()

   Dim hHwnd As Long
   Dim hHdc As Long
   Dim lKind As Long
   Dim lState As Long
   
   hHwnd = GetDesktopWindow
   hHdc = GetDC(hHwnd)
   lKind = 4     'PB_GROUPBOX
   lState = 1    'PBS_NORMAL
   
   ReleaseDC hHwnd, hHdc
   
   Set UserControl.Font = Ambient.Font
   Caption = Ambient.DisplayName
   meBackStyle = m_def_BackStyle
   BackStyle = m_def_BackStyle
   mUseThemeColors = True
   mUseColorCheat = False
   UserControl.Height = UserControl.TextHeight("T")
   
End Sub

Private Sub UserControl_Paint()

   Redraw

End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   Dim sFontString As String
   
   BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
   mUseThemeColors = PropBag.ReadProperty("Themed", True)
   mUseColorCheat = PropBag.ReadProperty("UseColorCheat", False)
   meUseParentFormhDC = PropBag.ReadProperty("UseParentFormhDC", False)
   ForeColor = PropBag.ReadProperty("ForeColor", vbButtonText)
   Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
   Caption = PropBag.ReadProperty("Caption", Ambient.DisplayName)
   FontUnderline = PropBag.ReadProperty("FontUnderline", False)
   FontTransparent = PropBag.ReadProperty("FontTransparent", True)
   FontStrikethru = PropBag.ReadProperty("FontStrikethru", False)
   FontSize = PropBag.ReadProperty("FontSize", False)
   FontName = PropBag.ReadProperty("FontName", "")
   FontItalic = PropBag.ReadProperty("FontItalic", False)
   FontBold = PropBag.ReadProperty("FontBold", False)
   meBackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
   
   If Ambient.UserMode Then
   
      Set MyParent = UserControl.Parent
      
   End If
         
   m_hWnd = UserControl.hWnd
   
   If mUseThemeColors Then
   
      On Error Resume Next
      Set UserControl.Font.Name = ThemeSysFont
      UserControl.FontName = ThemeSysFont
      On Error GoTo 0
      
   End If

End Sub

Private Sub UserControl_Resize()

   UserControl.Height = UserControl.TextHeight("T") '+ ScaleY(4, vbPixels, vbTwips)
   
   Redraw
      
End Sub

Private Sub UserControl_Show()

   Redraw

End Sub

Private Sub UserControl_Terminate()

   FreeLibrary m_hMod
   
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("BackColor", UserControl.BackColor, vbButtonFace)
   Call PropBag.WriteProperty("BackStyle", meBackStyle, Transparent)
   Call PropBag.WriteProperty("Themed", mUseThemeColors, True)
   Call PropBag.WriteProperty("UseParentFormhDC", meUseParentFormhDC, False)
   Call PropBag.WriteProperty("UseColorCheat", mUseColorCheat, False)
   Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, vbButtonText)
   Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
   Call PropBag.WriteProperty("Caption", mCaption, Ambient.DisplayName)
   Call PropBag.WriteProperty("FontUnderline", UserControl.FontUnderline, False)
   Call PropBag.WriteProperty("FontTransparent", UserControl.FontTransparent, True)
   Call PropBag.WriteProperty("FontStrikethru", UserControl.FontStrikethru, False)
   Call PropBag.WriteProperty("FontSize", UserControl.FontSize, False)
   Call PropBag.WriteProperty("FontName", UserControl.FontName, "")
   Call PropBag.WriteProperty("FontItalic", UserControl.FontItalic, False)
   Call PropBag.WriteProperty("FontBold", UserControl.FontBold, False)

End Sub

Private Sub Redraw()

   Dim tR As RECT
   Dim lR As Long
   Dim pDtgBopts As DTBGOPTS
   Dim hTheme As Long
   Dim cControlKind As Long
   Dim lFlags As Long
   Dim iCheatValue As Integer
   Dim pColor As OLE_COLOR
   Dim lColor As Long
   Dim lRetVal As Long
   Dim lpPoint As POINTAPI
   
   If IsThemed(UserControl.hWnd) Then              ' Draw themed control.
                  
      hTheme = OpenThemeData(UserControl.hWnd, StrPtr(ClassListItems.PSZ_BUTTON))
      
      If mUseColorCheat Then

         tR.Top = 0
         tR.Left = 0
         tR.Right = 10
         tR.Bottom = 4
                     
         lR = DrawThemeBackground(hTheme, UserControl.hDC, _
               BP_GROUPBOX, _
               PBS_NORMAL, _
               tR, tR)
   
         lColor = GetPixel(UserControl.hDC, tR.Left + 5, tR.Top)
         
      Else

         If GetThemeColor(hTheme, BP_GROUPBOX, PBS_NORMAL, TMT_BORDERCOLORHINT, pColor) = S_OK Then
            
            lColor = pColor ': Debug.Print lColor
         
         End If
      
      End If
      
      UserControl.Cls
      
      If lColor = 0 Then                           ' if all the above has failed...
   
         lColor = vbButtonShadow                   ' ... this is the next best thing IMO.
         
      End If
      
      tR.Top = 0
      tR.Left = 0
      tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels) + 4
      tR.Bottom = ScaleY(UserControl.Height - UserControl.ScaleTop, vbTwips, vbPixels)
      
      If BackStyle = Transparent Then
         
         MakeContainerTransparent
         
      End If
      
      UserControl.ForeColor = vbButtonText ' Reset to default incase the user switches
                                           ' between styles.
      If mUseThemeColors Then              ' Draw text in Theme GroupBox Caption Color.
         
         If lColor > 0 Then
                  
            UserControl.ForeColor = lColor
         
         End If
                  
         tR.Top = 0
         tR.Left = 0
         tR.Right = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + 4
         tR.Bottom = ScaleY(UserControl.Height - UserControl.ScaleTop, vbTwips, vbPixels)
         
         If LenB(mCaption) > 0 Then
                              
            DrawThemeText _
               hTheme, _
               UserControl.hDC, _
               BP_GROUPBOX, _
               PBS_NORMAL, _
               StrPtr(mCaption), _
               -1, _
               DT_LEFT Or DT_TOP, _
               0, _
               tR
         
            tR.Left = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + 4
         
         Else
         
            tR.Left = 0
         
         End If
         
         CloseThemeData hTheme
                                                
         tR.Top = ScaleY((UserControl.TextHeight("T") / 2), vbTwips, vbPixels)
         tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
         tR.Bottom = tR.Top
                                          
         UserControl.CurrentX = tR.Left
         UserControl.CurrentY = tR.Top
               
         MoveToEx UserControl.hDC, tR.Right, tR.Top, lpPoint
         LineTo UserControl.hDC, tR.Left, tR.Top
      
      Else                                      'Draw text in vbButtonText.
         
         If BackStyle = Transparent Then
            
            MakeContainerTransparent
            
         End If
         
         UserControl.ForeColor = vbButtonText
         
         tR.Top = 0
         tR.Left = 0
         tR.Right = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels)
         tR.Bottom = ScaleY(UserControl.Height - UserControl.ScaleTop, vbTwips, vbPixels)

         If LenB(mCaption) > 0 Then
         
            DrawText UserControl.hDC, mCaption, Len(mCaption), tR, vbButtonText
            
            tR.Left = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + 4
            
         Else

            tR.Left = 0

         End If
         
         tR.Top = ScaleY((UserControl.TextHeight("T") / 2), vbTwips, vbPixels)
         tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
         tR.Bottom = tR.Top + 1
         
         DrawEdge UserControl.hDC, tR, EDGE_ETCHED, BF_TOP
         
      End If
                  
   Else                                         'Fall back on default Windows controls.
       
      UserControl.Cls
      UserControl.ForeColor = vbButtonText
       
      tR.Top = 0
      tR.Left = 0
      tR.Right = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels)
      tR.Bottom = ScaleY(UserControl.Height - UserControl.ScaleTop, vbTwips, vbPixels)

      If BackStyle = Transparent Then
         
         MakeContainerTransparent
         
      End If

      If LenB(mCaption) > 0 Then
      
         DrawText UserControl.hDC, mCaption, Len(mCaption), tR, vbButtonText
         
            tR.Left = ScaleX(UserControl.TextWidth(mCaption), vbTwips, vbPixels) + 4
            
         Else

            tR.Left = 0

         End If
         
         tR.Top = ScaleY((UserControl.TextHeight("T") / 2), vbTwips, vbPixels)
         tR.Right = ScaleX(UserControl.Width, vbTwips, vbPixels)
         tR.Bottom = tR.Top + 1
         
         DrawEdge UserControl.hDC, tR, EDGE_ETCHED, BF_TOP
      
   End If
      
End Sub

Private Sub ProcessChanges()
   
   UserControl.Height = UserControl.TextHeight("T")
      
End Sub

'Code by vbAccelerator.com
Private Function TranslateColor(Color As OLE_COLOR) As OLE_COLOR
  If (Color And COL_SYS_MASK) Then                                    'If the system color bit is set
    TranslateColor = GetSysColor(Color Xor COL_SYS_MASK)              'Get the translated system color
  Else
    TranslateColor = Color                                            'Not a system color
  End If
End Function

   '*************************************************************************
   '* This function is written by GumbyTheCat and used with his permission. *
   '*************************************************************************

Private Sub MakeContainerTransparent()

   '*************************************************************************
   '* displays what's behind the container control, thereby effectively     *
   '* rendering the container Transparent.                                  *
   '*************************************************************************

   On Error Resume Next

   Dim r As Long
   Dim ctl              As Control
   Dim rc               As RECT
   Dim h1               As Long, h2 As Long
   
   h2 = UserControl.hDC               ' the dc of this control.
   
   If Not meUseParentFormhDC Then     ' Added by Jottum
   
      If UserControl.Parent.hWnd = UserControl.ContainerHwnd Then
         'the container resides on a Form, so use parent hDC.
         UserControl.Parent.AutoRedraw = True ' added by mru
         h1 = UserControl.Parent.hDC
      Else
         'the container resides in another container, so use parent container's hDC.
         For Each ctl In UserControl.Parent.Controls
         'find container.
            If ctl.hWnd = UserControl.ContainerHwnd Then 'Found our container
               ctl.AutoRedraw = True 'AutoRedraw must be True
               h1 = ctl.hDC 'Get the containers hDC
               Exit For
            End If
         Next
      End If
   
   '  get offsets for BitBlt.
      If UserControl.Extender.Container.ScaleMode = vbTwips Then
         rc.Left = UserControl.Extender.Left \ Screen.TwipsPerPixelX
         rc.Top = UserControl.Extender.Top \ Screen.TwipsPerPixelY
         rc.Right = (UserControl.ScaleWidth \ Screen.TwipsPerPixelX)
         rc.Bottom = (UserControl.ScaleHeight \ Screen.TwipsPerPixelY)
      Else
         rc.Left = UserControl.Extender.Left
         rc.Top = UserControl.Extender.Top
         rc.Right = UserControl.ScaleWidth
         rc.Bottom = UserControl.ScaleHeight
      End If
   
   Else
   
      UserControl.Extender.Parent.AutoRedraw = True ' added by Jottum
      h1 = UserControl.Extender.Parent.hDC
      
      pGetClientRect rc
      
   End If
   
'  Copy background to our usercontrol hDC.
   r = BitBlt(h2, 0, 0, rc.Right, rc.Bottom, h1, rc.Left, rc.Top, vbSrcCopy)

End Sub

Public Sub Refresh()
   Redraw
   UserControl.Refresh
End Sub

Private Sub MyParent_Resize()

   Redraw

End Sub

Private Sub MyParent_Paint()

   Redraw

End Sub

'Code by vbAccelerator.com
Private Sub pGetClientRect(rc As RECT)
Dim tP As POINTAPI
    ' Get window rect of the user control:
    GetWindowRect UserControl.hWnd, rc
    tP.X = rc.Left
    tP.Y = rc.Top
    ' Adjust to coordinates of user control's container:
    ScreenToClient UserControl.Parent.hWnd, tP
    rc.Right = rc.Right + (tP.X - rc.Left)
    rc.Bottom = rc.Bottom + (tP.Y - rc.Top)
    rc.Left = tP.X
    rc.Top = tP.Y
End Sub

